from qt import *
from uidcasos import DialogoCasos
#Dialogo de casos

#comboBox1 elige un valor
#lineEdit2:  zona donde escribes la nueva clave
#lineEdit1:  zona donde escribes el nuevo valor
#pushButton3: Aadir la entrada a la lista
#listBox1: Donde se muestra todo

#PushButton2: Boton de borrar
#PushButton4: Boton aceptar


class DCasos(DialogoCasos):
	def __init__(self,parent = None,name = None,modal = 0,fl = 0):
		DialogoCasos.__init__(self,parent,name,modal,fl)
		self.__conexiones()
		self.listBox1.clear()
		self.variable=None

	def __conexiones(self):
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.addclave)

	def show(self,variable):
		self.variable=variable
		self.listBox1.clear()
		print self.variable
		if variable!=None:
			if self.parent().parent().dato.get_var(variable).valores==None:
				self.parent().parent().dato.get_var(variable).valores=Dict() #Inicializacion porsiaca
				#EXCEPCION
			else:
				#Bucle de parejitas
				print self.parent().parent().dato.get_var(variable).valores
				for pareja in self.parent().parent().dato.get_var(variable).valores.items():
					self.listBox1.insertItem(str(pareja[0])+"      "+str(pareja[1]))
					print pareja
		DialogoCasos.show(self)

	def addclave(self):
		if self.variable!=None and self.lineEdit2.text().latin1() and self.lineEdit1.text().latin1(): #Tiene que existir la variable destino, el valor y la clave
			#De momento solo trabaja con enteros como indices
			self.parent().parent().dato.get_var(self.variable).valores[int(self.lineEdit2.text().latin1())]=self.lineEdit1.text().latin1()
			self.show(self.variable)

	def accept(self):
		self.variable=None
		DialogoCasos.accept(self)

