#!/usr/bin/python
# -*- coding: latin-1 -*-


#Implementar la opción de splash
import sys
sys.path.append("./dialog/dconfig/")

from uidconfig import DialogoConfig
from uiwconfig1 import wconfig1
from qt import *

class DConfig(DialogoConfig):
	def __init__(self,parent=None,name=None,modal=0,fl=0):
		DialogoConfig.__init__(self,parent,name,modal,fl)
		self.cambio=False
		self.estado=0 # Es el estado, el apartado en el que se encuentra la pantalla.
		# El valor inicial es 0. IMPORTANTE PENDIENTE IMPLEMENTAR
		#Poblar ListBox
		self.listBox.clear()
		self.listBox.insertItem("General")
		
		#Inicializacion de widgets
		self.wgeneral=wconfig1(self.groupBox1,"ficheros",)
		#Seleccionar por defecto el valor 0 y poblarlo
		self.__poblarcaja(0)
		self.__conexiones()


	def accept(self):
		"""Funcion que es heredada pero conviene cambiar para preguntar si hay que guardar
		"""
		if not self.cambio:
			DialogoConfig.accept(self)
		else:
			self.cambio=False # Volvemos a ponerlo en falso
			rc = QMessageBox.information(self,'Atencion: Guardar', 'Ha cambiado la configuración, desea guardarla?', 'Guardarla','Cancelar','Dejarlo estar',0,1)
			if rc == 0:
				#Crear una interfaz usuario configuracion #DECISION DE DISEÑO, pendiente
				self.__guardarconfig()
				DialogoConfig.accept(self)
			elif rc == 2:
				DialogoConfig.reject(self)
			else:
				self.cambio=True
				



	def __poblarcaja(self,numero): # El nuemro es el indice de la listBox
		if numero==0:
			#Poblar el valor 0 (Configuracion general)
			self.groupBox1.setTitle("Ficheros")
			layout0=QHBoxLayout(self.groupBox1)
			layout0.addWidget(self.wgeneral)
			self.wgeneral.lineEdit1.setText(self.parent().parent().config["tmpdir"])
			self.wgeneral.lineEdit2.setText(self.parent().parent().config["rdir"])

	def __conexiones(self):
		self.connect(self.wgeneral.lineEdit1,SIGNAL("textChanged(const QString&)"),self.__cambio)

	def __cambio(self):
		self.cambio=True
	def __guardarconfig(self):
		self.parent.config["tmpdir"]=str(self.wgeneral.lineEdit1.text())
		self.parent.config["rdir"]=str(self.wgeneral.lineEdit2.text())
		self.parent.config.save()
