#!/usr/bin/python
# -*- coding: latin-1 -*-

from qt import *
import sys

class Principal(QApplication):
    
    def __init__(self, args):
        """ In the constructor we're doing everything to get our application
            started, which is basically constructing a basic QApplication by 
            its __init__ method, then adding our widgets and finally starting 
            the exec_loop."""
        QApplication.__init__(self,args)
        
        # We pass None since it's the top-level widget, we could in fact leave 
        # that one out, but this way it's easier to add more dialogs or widgets.
        self.maindialog = QPushButton("Say 'Hello world!'",None)
        self.setMainWidget(self.maindialog)
        self.maindialog.show()
        self.exec_loop()     


