#Clases de elementos correspondientes a la ventana de salida

class elemento:
	"""Clase elemento generico, Funciones de transformacin a html, y quiza exportacin
	   Facilitaria la labor de borrar agrupado
	"""
	def __init__(self,nivel):
		self.dato=None
		self.titulo=""
		self.nivel=nivel  # El nivel determina cuantos padres tiene, para saber el tamao de los titulos y otros
	def set_tit(self,titulo):
		sef.titulo=titulo
	def set(self,dato):
		self.dato=dato
	def get_html(self):
		return ""


class contenedor(elemento):
	def __init__(self,nivel=0):
		elemento.__init__(self,nivel)
		self.lista=[]
	def append(self,valor):
		self.lista.append(valor)
	def get_html(self):
		resultado=""
		for elemento in self.lista:
			resultado+=elemento.get_html()
		return resultado
			
class tabla(elemento):
	"""Clase que de una lista de listas + un titulo saca una tabla"""
	def __init__(self,dato=[],nivel=0):
		elemento.__init__(self,nivel)
		self.dato=dato
	def set(self,dato):
		"""Se supone que es un array de array"""
		self.dato=dato
	def get_html(self):
		resultado="<table border=1>"
		for fila in self.dato:
			resultado+="<tr>"
			for columna in fila:
				resultado+="<td>"+repr(columna)+"</td>"
				print repr(columna)
			resultado+="</tr>"
		resultado+="</table>"
		return resultado

class imagen(elemento):
	def __init__(self,ruta="",nivel=0):
		elemento.__init__(self,nivel)
		self.dato=ruta
	"""Idem, Quiza una leyenda"""
	def set(self,rutaimagen):
		self.dato=rutaimagen
	def get_html(self):
		return "<img src=%s> % str(self.dato)"


class texto(elemento):
	"""Clase para texto, tendra alguna opcion de formato"""
	def __init__(self,valor="",nivel=0):
		elemento.__init__(self,nivel)
		self.dato=valor
	def set(self,texto):
		self.dato=texto
	def get_html(self):
		return "<P>"+self.dato


