#####
# Fichero de tipos
# Guarda todos los tipos relacionados con los tipos que maneja el programa
####

class Tipo:
	"""Tipo generico. De esta clase heredan los tipos usados en el programa """
	def __init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto):
		self.nombre=nombre
	#	if self.comprobar(valorpordefecto):
		self.valorpordefecto=valorpordefecto
		self.titulo=titulo
		self.ancho=ancho
		self.decimales=decimales
		if valores == None: self.valores={}
		else: self.valores=dict()
	
	def set_val(self,array):
		"""Coge todos los valores que caracterizan a la variable de un array"""
		(self.nombre,self.titulo,self.ancho,self.decimales,self.valores)=array
	def get_val(self):
		return [self.nombre,self.titulo,self.ancho,self.decimales,self.valores]

	def __setitem__(self,indice,valor):
		if indice==0:
			self.nombre=valor
			print valor
		elif indice==2:
			self.titulo=valor
		else:
			print "no implementdo"
	def comprobar(self,valor):
		"""Funcin de comprobacin de la correctitud de un valor"""
		return True

class Entero(Tipo):
	def __init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto):
		Tipo.__init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto)
		self.tipo="Entero"
	def comprobar(self,valor):
		"""Compara con una expresin regular"""
		#http://honors.montana.edu/~jjc/easytut/easytut/node16.html
		#Aprovecha la funcion eval de python
		#import types
		#if type(int(valor))==types.IntType: return True
		#Mejor capturar la excepcion al hacer la funcion int
		return True

def TEntero(objeto,datos):
	"""Esta funcion convierte cualquier tipo en tipo entero"""
	if isinstance(objeto,Entero):
		return objeto
	elif isinstance(objeto,Real):
		datos[objeto]=[int(x) for x in datos[objeto]]
		return Entero(objeto.nombre,objeto.titulo,objeto.valores,objeto.ancho,0,objeto.valorpordefecto) #PENDIENTE

class Real(Tipo):
	def __init__(self,nombre=None,titulo=None,valores=None,ancho=None,decimales=None,valorpordefecto=None):
		Tipo.__init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto)
	def comprobar(self,valor):
		"""Compara con una expresin regular"""
		pass 

class Booleano(Tipo):
	def __init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto):
		Tipo.__init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto)
		self.tipo="Booleano"
	def comprobar(self,valor):
		"""Compara con una expresin regular"""
		pass 

def TBooleano(objeto,datos):
	"""Esta funcion convierte cualquier tipo en tipo Booleano"""
	if isinstance(objeto,Booleano):
		return objeto
	elif isinstance(objeto,Entero):
		def es(algo):
			if algo: return True
			return False
		datos[objeto]=[es(int(x)) for x in datos[objeto]]
		return Booleano(objeto.nombre,objeto.titulo,objeto.valores,objeto.ancho,objeto.decimales,objeto.valorpordefecto) #PENDIENTE

class Fecha(Tipo):
	def __init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto):
		Tipo.__init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto)
	def comprobar(self,valor):
		"""Compara con una expresin regular"""
		pass 

class Dinero(Tipo):
	def __init__(self=None,nombre=None,titulo=None,valores=None,ancho=None,decimales=None,valorpordefecto=None):
		Tipo.__init__(self,nombre,titulo,valores,ancho,decimales,valorpordefecto)
		self.tipo="Dinero"
	def comprobar(self,valor):
		"""Compara con una expresin regular"""
		return True

def TDinero(objeto,datos):
	"""Esta funcion convierte cualquier tipo en tipo dinero"""
	if isinstance(objeto,Dinero):
		return objeto
	elif isinstance(objeto,Real):
		return Real(objeto.nombre,objeto.titulo,objeto.valores,objeto.ancho,objeto.decimales,objeto.valorpordefecto) #PENDIENTE

