import pickle
import datos
# Gestion de ficheros de configuracion

# Elementos a configurar:

	#tmpdir: Guarda la ruta del directorio de trabajo
	#rdir:   Guarda la ruta del ejecutable de R
	#vsplash: boolean que dice si aparece la ventana splash o no
	#lfichero: Tipo especial derivado de lista que guarda la lista de ficheros más recientes





class ConfigHandler:
	"""Clase que maneja la config
	ALTERNATIVA:pprint.pprint(dict_configuracion, open(configuracion, 'w'))
	"""
	def __init__(self):
		self.parametros={}
		try:
			self.archivo=open("./drizaconfig","r")
		except: #Archivo nuevo.. supongo
			self.archivo=open("./drizaconfig","w")
			pickle.dump(self.__default(),self.archivo)
			self.archivo.close()
			self.archivo=open("./drizaconfig","r")
		self.parametros=pickle.load(self.archivo)
		self.archivo.close()
	def __default(self):
		listado=datos.Listaficheros()
		return {"tmpdir":"/tmp","rdir":"/home/bourbaki/src/r/R-2.2.0/bin/R","lfichero":listado}
	def __getitem__(self,valor):
		return self.parametros[valor]
	def __setitem__(self, clave, valor):
		"""Funcion para establecer la clave de un valor
		"""
		if not clave in self.parametros:
			self.parametros.append(clave)
		self.parametros[clave]=valor
	def save(self):
		self.archivo=open("./drizaconfig","w")
		pickle.dump(self.parametros,self.archivo)
		self.archivo.close()

