from uidcrevar import DialogoCrevar
from qt import *

#Dialogo de creacion de variables

#listbox1: Variables disponibles
#pushButton1: Boton de inclusion de variable en caja de texto
#textEdit1: Caja de escritura
#pushButton2: aceptar
#pushButton4 Inclusión de función en caja de texto
#listbox2: listado categoria funciones
#listbox3: listado funciones
#lineEdit2: Caja con el nombre de la variable




class DCrevar(DialogoCrevar):
	def __init__(self,parent=None,name=None,modal=0,fl=0):
		self.driza=parent.parent()
		DialogoCrevar.__init__(self,parent,name,modal,fl)
		self.__conexiones()
	

	def __conexiones(self):
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.__nombrecaja)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.accept)

	def show(self):
		self.__actualizarcaja1()
		DialogoCrevar.show(self)


	def __actualizarcaja1(self):
		"""Actualiza la caja de variables disponibles"""
		self.listBox1.clear()
		i=0
		for var in self.driza.dato.arr_tit():
			self.listBox1.insertItem(var,i)
			i+=1
	
	def __nombrecaja(self):
		"""Coge el valor seleccionado y lo añade en la caja de texto"""
		if self.listBox1.currentItem() != -1:
			texto=self.listBox1.currentText().latin1()
			self.textEdit1.insert(texto)
	def accept(self):
		"""Funcion de aceptacion del dialogo"""
		# Creo un objeto con lo que me pasan a ver si hay una excepción o no
		guay=True
		try:
			compile(self.textEdit1.text().latin1(),self.driza.config["tmpdir"]+"/objetotmp",'single')
		except SyntaxError:
			#enseñarventana de aviso
			QErrorMessage(self,"error").message("No esta bien la expresión")
			guay=False
		else:
			#llamar a la funcion de driza que crea la nueva variable
			self.driza.crearvariable(self.lineEdit2.text().latin1(),self.textEdit1.text().latin1())
			DialogoCrevar.accept(self)
#			import os
#			os.remove(self.driza.config["tmpdir"]+"/objetotmp") #borro el archivo ... NO SE PORQUe NO EXISTE


